#include <libps.h>
#include "MyPad.h"

#define OT_LENGTH	1
#define PACKETMAX	2048
#define PACKETMAX2	(PACKETMAX*24)
#define DUCK_ADDRESS 0x80090000 

#define scaleRotate(_s,_x,_y,_r) (_s)->scalex += (_x), (_s)->scaley += (_y), (_s)->rotate += (_r)
#define setRGB(_s,_r,_g,_b) (_s)->r = (_r), (_s)->g = (_g), (_s)->b = (_b)

//  Ordering table related variables
GsIMAGE screenTextureInfo;
GsOT		WorldOT[2];
GsOT_TAG	OTTags[2][1<<OT_LENGTH];
static PACKET packetArea[2][PACKETMAX2];


void CoolFade(u_char r, u_char g, u_char b, u_long scale, long rotate, u_long length, short x, short y, u_char type);

void main(void) {
	int	i, activeBuff;
	RECT rect;

	SetVideoMode(MODE_PAL);
	GsInitGraph(320, 256, 4, 0, 0);
	GsDefDispBuff(0,0,0, 256);
	GsDISPENV.screen.h=256;
	GsSetOrign(0,0);
	
	// Ordering table information setting
	for (i = 0; i < 2; i++) {
		WorldOT[i].length = OT_LENGTH;
		WorldOT[i].org = OTTags[i];
	}
	GsClearOt(0,0,&WorldOT[0]);
	GsClearOt(0,0,&WorldOT[1]);

	// Dump rubber duck onto active screen buffer
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	
// r, g, b, scale, rotate, number of frames, x, y, dynamic / constant scaling & rotation

	// Dynamic fade
	CoolFade(128, 128, 128, 8, 256, 128, 160, 128, 1);
	
	// Constant fade
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(127, 127, 127, 512, -16384, 64, 160, 128, 0);

	// Red fade
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(128, 127, 127, 8, -256, 128, 160, 128, 1);
	
	// Green fade
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(127, 128, 127, 8, 256, 128, 160, 128, 1);
	
	// Blue fade
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(127, 127, 128, 8, -256, 128, 160, 128, 1);
	
	// Fade down
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(127, 127, 127, 256, 16384, 64, 160, 132, 0);
	
	// Fade out
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(127, 127, 127, 0, 0, 64, 160, 128, 1);
	
	// Cool Fade
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(127, 100, 127, 512, -16384, 64, 156, 132, 0);
	
	// Zoom Fade to red to black
	activeBuff = GsGetActiveBuff();
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	LoadImage(&rect, (u_long *)(DUCK_ADDRESS+4));
	DrawSync(0);
	CoolFade(128, 127, 127, 512, 0, 64, 160, 128, 0);
	CoolFade(127, 127, 127, 0, 0, 64, 160, 128, 0);
	
	
	printf("That's the lot!\n");
}



void CoolFade(u_char r, u_char g, u_char b, u_long scale, long rotate, u_long length, short x, short y, u_char type) {
	int	i, j;
	int	activeBuff = GsGetActiveBuff();
	GsSPRITE leftSprite, rightSprite;
	RECT rect;
	u_long row[160];
	// Now using seperate sprites for each area of the screen
	leftSprite.attribute = (1<<25)+(1<<30);
	leftSprite.x = x;
	leftSprite.y = y;
	leftSprite.w = 256;
	leftSprite.h = 256;
	leftSprite.u = 0;
	leftSprite.v = 0;
	leftSprite.mx = 160;
	leftSprite.my = 128;
	leftSprite.scalex = ONE;
	leftSprite.scaley = ONE;
	leftSprite.rotate = 0;

	rightSprite.attribute = (1<<25)+(1<<30);
	rightSprite.x = x;
	rightSprite.y = y;
	rightSprite.w = 64;
	rightSprite.h = 256;
	rightSprite.u = 0;
	rightSprite.v = 0;
	rightSprite.mx = -96;
	rightSprite.my = 128;
	rightSprite.scalex = ONE;
	rightSprite.scaley = ONE;
	rightSprite.rotate = 0;

	setRGB(&leftSprite, r, g, b);
	setRGB(&rightSprite, r, g, b);
	
	setRECT(&rect, 0, activeBuff<<8, 320, 256);
	MoveImage(&rect, 0, (1-activeBuff)<<8);

// For every y value in each frame buffer (buffer 0 is 0->255, buffer 1 is 256->511)
// grab a row of pixels and set the transparency bit. Not a quick as the old method :(
// but uses much less memory :)
	setRECT(&rect, 0, 0, 320, 1);
	for (j=0; j<512; j++) {
		rect.y = j;
		StoreImage(&rect, row);
		DrawSync(0);
		for (i=0; i<160; i++)
			row[i] |= (1<<15) + (1<<31);
		LoadImage(&rect, row);
		DrawSync(0);
	}

		if (type==0) {
			scaleRotate(&leftSprite, scale, scale, rotate);
			scaleRotate(&rightSprite, scale, scale, rotate);
		}

// A much tighter drawing loop with no hideously long for loop :)
	for (i=0; i<length; i++) {
		activeBuff = GsGetActiveBuff();
		GsSetWorkBase((PACKET *)packetArea[activeBuff]);
		GsClearOt(0, 0, &WorldOT[activeBuff]);
	
		if (type) {
			scaleRotate(&leftSprite, scale, scale, rotate);
			scaleRotate(&rightSprite, scale, scale, rotate);
		}
		
		leftSprite.tpage = GetTPage(2,0,0,activeBuff<<8);
		GsSortSprite(&leftSprite, &WorldOT[activeBuff], 0);
	
		rightSprite.tpage = GetTPage(2,0,256,activeBuff<<8);
		GsSortSprite(&rightSprite, &WorldOT[activeBuff], 0);
		
   		DrawSync(0);
		VSync(0);
		GsSwapDispBuff();
		GsDrawOt(&WorldOT[activeBuff]);
	}
}